
; build option

; Enable countermeasures for joypad reading errors when using DPCM
OPT_JOYPAD_DMC_MEASURES	.equ	1

; system defined variables

FNC_WORK	.equ	$00 ; 12 bytes
FNC_ARG		.equ	$0c ;  8 bytes
MATH_REG	.equ	$14 ; 12 bytes
; for user $20 .. $af
; for user (debug) $b0 .. $b7
; use USR_FNC .. $b8
USR_FNC		.equ	$b9 ;  2bytes
IRQ_LINE	.equ	$bb
; free $bc .. $bf
; for sound driver $c0 .. $ef
SCROLL_X	.equ	$f0
SCROLL_Y	.equ	$f1
JOYPAD		.equ	$f2 ;  2 bytes
RAND		.equ	$f4 ;  2 bytes
VCMD_SIZE	.equ	$f6
SPR_UPD		.equ	$f7
SUS_BANK	.equ	$b8 ;  2bytes
SUS_IRQ_X	.equ	$fa
SUS_IRQ_Y	.equ	$fb
SUS_NMI_X	.equ	$fc
SUS_NMI_Y	.equ	$fd
PPU_REG1	.equ	$fe
SYS_CNT		.equ	$ff

VCMD_DATA	.equ	$0100
VCMD_LIMIT	.equ	$01a0
STK_BASE	.equ	$01d0
; free $01d0 .. $01df
SUS_WORK	.equ	$01e0 ; 20 bytes
VCMD_SEQ	.equ	$01f4 ;  2 bytes
TSK_FNC		.equ	$01f6 ;  2 bytes
FRM_FNC		.equ	$01f8 ;  2 bytes
; use IRQ_FNC .. $01fa
IRQ_FNC		.equ	$01fb ;  3 bytes
; use NMI_FNC .. $01fd
NMI_FNC		.equ	$01fe ;  3 bytes

SPR_DATA	.equ	$0200

; for sound driver $0300 .. $037f
; for user $0380 .. $07ff

; constants

JOY_A		.equ	$80
JOY_B		.equ	$40
JOY_SELECT	.equ	$20
JOY_START	.equ	$10
JOY_UP		.equ	$08
JOY_DOWN	.equ	$04
JOY_LEFT	.equ	$02
JOY_RIGHT	.equ	$01

; functions

VCMD_SET	.macro
		.dw	(\4)-(\3)+((\1)<<8), (\2), (\3)
		.endm

VCX	.func	(((\1)<<6)|((\2)-1))

